//File [Ascolta]
import java.net.*;
import java.io.*;

public class Ascolta extends Thread {
	static SemaforoFCFS mutex = new SemaforoFCFS(1);
	static boolean entrambi=false;
	Film film;
	int tipo;
	int tiposerver; //0 master; 1 slave
	Socket connClient;
	static ObjectOutputStream out1; //manda richieste lo slave
	static ObjectInputStream in1;
	static Socket connMS1;
	static ObjectOutputStream out2; //manda richieste il master
	static ObjectInputStream in2;
	static Socket connMS2;
	static ServerSocket masterslave;
	
	public Ascolta(int tipo,Film film, ServerSocket ss,int tiposerver) {
		this.tipo=tipo;
		this.film=film;
		masterslave=ss;
		this.tiposerver=tiposerver;
	}
	
	public Ascolta(int tipo,Film film,Socket conn,int tiposerver) {
		this.tipo=tipo;
		this.film=film;
		this.connClient=conn;
		this.tiposerver=tiposerver;
	}	
	
	public Ascolta(int tipo,Film film,int tiposerver) {
		this.tipo=tipo;
		this.film=film;
		this.tiposerver=tiposerver;
	}

	public Ascolta(int tipo,Socket s1,Socket s2,int tiposerver) {
		this.tipo=tipo;
		connMS1=s1;//lo slave invia richieste
		connMS2=s2;//il master invia richieste
		this.tiposerver=tiposerver;
	}
	
	private synchronized void stampa() {
		int[] posti=new int[Film.nsale];
		film.VediPostiDisponibili(posti);
		System.out.println("--------------------------------------");
		for (int i=0;i<Film.nsale;i++) 
		  System.out.println("Sala " + (i+1) + ": "+ posti[i] + " posti disponibili");
		System.out.println("--------------------------------------");
	}
	
	private void gestisciClient(){
		try {
			boolean scelta;
			ObjectOutputStream outClient = new ObjectOutputStream(connClient.getOutputStream());
			ObjectInputStream inClient = new ObjectInputStream(connClient.getInputStream());
			do {
				scelta=true;
				try {
					int sala;
					int posti;
					boolean risultato=false;
					boolean risultatodaaltroserver;
					outClient.writeInt(Film.nsale);
					int[] postidisponibili = new int[Film.nsale];
					film.VediPostiDisponibili(postidisponibili);
					for (int i=0;i<Film.nsale;i++) 
			  		outClient.writeInt(postidisponibili[i]);
					outClient.flush();
					sala=inClient.readInt();
					sala= sala - 1;
					posti=inClient.readInt();
					
					mutex.Entra();
					if(!entrambi) { 
						try {
							risultato=film.CambiaPostiDisponibili(sala,posti);
							outClient.writeBoolean(risultato);
							outClient.flush();
							if (risultato) {
								boolean commit=inClient.readBoolean();
								stampa();
							}
						} catch (IOException io) {
							if (risultato) {
								film.AggiornaPostiDisponibili(sala,posti);
								System.out.println("Non ho ricevuto conferma dal client");
								System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
							}
						}
					}
					else {
						if(tiposerver==0) { //master
							try {
								out2.writeInt(sala);
								out2.writeInt(posti);
								out2.flush();
								risultatodaaltroserver=in2.readBoolean();
								if(!risultatodaaltroserver) {
									try {
										outClient.writeBoolean(risultatodaaltroserver);
										outClient.flush();
									} catch (IOException io) {}
								} else {
									risultato=film.CambiaPostiDisponibili(sala,posti);
									if(!risultato) System.out.println("ERRORE: Tabelle Inconsistenti");
									try {
										outClient.writeBoolean(risultato);
										outClient.flush();
										if (risultato) {
											//System.out.println("Ho inviato risultato al client, se vado avanti aspetto commit");
											//Pausa.premiEnter();
											boolean commit = inClient.readBoolean();
											try {
												//System.out.println("Ho ricevuto commit dal client, se vado avanti invio commit allo slave");
												//Pausa.premiEnter();
												out2.writeBoolean(true);
												out2.flush();
											} catch(IOException io) {
												entrambi=false;
												attesaAltroServer();
											}
											stampa();
										}
									} catch (IOException io) {
										try {
											out2.writeBoolean(false);
											out2.flush();
										} catch(IOException io1) {
											entrambi=false;
											attesaAltroServer();
										}
										film.AggiornaPostiDisponibili(sala,posti);
										System.out.println("Non ho ricevuto conferma dal client");
										System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
									}
								}
							}	catch (IOException io) {
								entrambi=false;
								attesaAltroServer();
								try {
									risultato=film.CambiaPostiDisponibili(sala,posti);
									outClient.writeBoolean(risultato);
									outClient.flush();
									if (risultato) {
										boolean commit=inClient.readBoolean();
										stampa();
									}
								} catch (IOException io1) {
									if (risultato) {
										film.AggiornaPostiDisponibili(sala,posti);
										System.out.println("Non ho ricevuto conferma dal client.");
										System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
									}
								}
							}
						} else { //Slave
							risultato=film.CambiaPostiDisponibili(sala,posti);
							if(!risultato) {
								try {
									outClient.writeBoolean(risultato);
									outClient.flush();
								} catch (IOException io) {}
							} else {
								try {
									out1.writeInt(sala);
									out1.writeInt(posti);
									out1.flush();
									risultatodaaltroserver=in1.readBoolean();
									if(!risultatodaaltroserver) {
										System.out.println("ERRORE: Tabelle Inconsistenti");
									}
									try {
										outClient.writeBoolean(risultato);
										outClient.flush();
										//System.out.println("Ho inviato risultato al client, se vado avanti aspetto commit");
										//Pausa.premiEnter();
										if (risultato) {
											boolean commit = inClient.readBoolean();
											//System.out.println("Ho ricevuto commit dal client, se vado avanti invio commit al master");
											//Pausa.premiEnter();
											try {
												out1.writeBoolean(true);
												out1.flush();
											} catch(IOException io) {
												entrambi=false;
												attesaAltroServer();
											}
											stampa();
										}
									} catch (IOException io) {
										try {
											out1.writeBoolean(false);
											out1.flush();
										} catch(IOException io1) {
											entrambi=false;
											attesaAltroServer();
										}
										film.AggiornaPostiDisponibili(sala,posti);
										System.out.println("Non ho ricevuto conferma dal client");
										System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
									}
								}	catch (IOException io) {
									entrambi=false;
									attesaAltroServer();
									try {
										outClient.writeBoolean(risultato);
										outClient.flush();
										boolean commit=inClient.readBoolean();
										stampa();
									} catch (IOException io1) {
										if (risultato) {
											film.AggiornaPostiDisponibili(sala,posti);
											System.out.println("Non ho ricevuto conferma dal client");
											System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
										}
									}
								}
							}
						}
					}
					mutex.Esci();

					try {
						scelta=inClient.readBoolean();
					} catch (IOException io1) {}
				} catch (IOException io) {}
			} while (!scelta);	
		
			try	{	
				outClient.close();
				inClient.close();
				connClient.close();
			} catch (IOException e) {}
		} catch (IOException io) {}
	}

	private void attesaAltroServer() {
		try { 
			out1.close(); in1.close(); connMS1.close();
			out2.close(); in2.close(); connMS2.close();
		} catch (IOException io) {}
		Ascolta attendi=new Ascolta(0,film,tiposerver);
		attendi.start();
	}

	private void attendiAltroServer() {
		try {
			connMS1=masterslave.accept();
			connMS2=masterslave.accept();
			out1 = new ObjectOutputStream(connMS1.getOutputStream());
			in1 = new ObjectInputStream(connMS1.getInputStream());
			out2 = new ObjectOutputStream(connMS2.getOutputStream());
			in2 = new ObjectInputStream(connMS2.getInputStream());
			int[] posti=new int[Film.nsale];
			mutex.Entra();
			film.VediPostiDisponibili(posti);
			boolean errore=false;
			try { 
				for(int i=0;i<Film.nsale;i++)
					out1.writeInt(posti[i]);
				out1.flush();
			} catch (IOException io) {errore=true;}
			if (errore) {
				attesaAltroServer();				
			} else {
				stampa();
				Ascolta ricevi = new Ascolta(2,film,tiposerver);
				ricevi.start();
				entrambi=true;
			}
			mutex.Esci();
		} catch (IOException io) {
			attesaAltroServer();
		}
	}	
	
	private void gestisciRichiesteAltroServer() {
		int sala=0;
		int posti=0;
		boolean ris=false;
		boolean commit=false;
		try {
			while(true) {
				ris = false;
				if(tiposerver==0) { //master
					sala=in1.readInt();
					posti=in1.readInt();
					ris=film.CambiaPostiDisponibili(sala,posti);
					if (!ris) {
						System.out.println("ERRORE: tabelle inconsistenti");
					} else {
						out1.writeBoolean(ris);
						out1.flush();
						commit=in1.readBoolean();
						if(!commit) {
							film.AggiornaPostiDisponibili(sala,posti);
							System.out.println("Non ho ricevuto conferma dal client");
							System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
						}	else stampa();
					}
				} else { //slave
					sala=in2.readInt();
					posti=in2.readInt();
					ris=film.CambiaPostiDisponibili(sala,posti);
					out2.writeBoolean(ris);
					out2.flush();
					if(ris) {
						commit=in2.readBoolean();
						if(!commit) {
							film.AggiornaPostiDisponibili(sala,posti);
							System.out.println("Non ho ricevuto conferma dal client");
							System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
						}	else stampa();
					}
				}
			}
		} catch (IOException io) {
			if (ris) {
				film.AggiornaPostiDisponibili(sala,posti);
				System.out.println("Non ho ricevuto conferma dall'altro server.");
				System.out.println("Rendo disponibili " + posti + " posti per la sala " +(sala+1));
			}
			mutex.Entra();
			if (entrambi) {
				System.out.println("Altro server caduto");
				entrambi=false;
				attesaAltroServer();
				mutex.Esci();
			}
		}
	}
	
	private void riceviTabellaDaAltroServer() {
		int portaserver,porta;
		String nome;
		
		if(tiposerver==0) { //master
			portaserver=Def.portaMasterSlave;
			porta=Def.portaMaster;
			nome="master";
		} else { //slave
			portaserver=Def.portaSlaveMaster;
			porta=Def.portaSlave;
			nome="slave";
		}
		try { 
			masterslave = new ServerSocket(portaserver);
			try {
				out1 = new ObjectOutputStream(connMS1.getOutputStream());
				in1 = new ObjectInputStream(connMS1.getInputStream());			
				out2 = new ObjectOutputStream(connMS2.getOutputStream());
				in2 = new ObjectInputStream(connMS2.getInputStream());			
				int[] posti = new int[Film.nsale];
				for(int i=0;i<Film.nsale;i++) 
					posti[i]=in1.readInt();
				film = new Film(posti);
				stampa();
				entrambi=true;
				Ascolta ricevi = new Ascolta(2,film,tiposerver);
				ricevi.start();
				try {
					ServerSocket client = new ServerSocket(porta);
					Socket conn;
					while(true) {
						conn=client.accept();
						Ascolta ascoltaclient = new Ascolta(1,film,conn,tiposerver);
						ascoltaclient.start();
					}
				} catch (IOException io) {
					System.out.println("Il server " + nome + "  caduto");
				}
			} catch (IOException io) {
				System.out.println("ERRORE: altro server caduto durante la sincronizzazione");
			}
		} catch (IOException io) {
			System.out.println("ERRORE: non riesco a creare la ServerSocket");
			System.out.println("        per l'eventuale caduta dell'altro server.");
		}
	}

	public void run() {
		switch (tipo) {
			case 0 : 	attendiAltroServer();
								break;
			case 1 :	gestisciClient();
								break;
			case 2 :	gestisciRichiesteAltroServer();
								break;
			case 3 :	riceviTabellaDaAltroServer();
		}
	}
}