//File [Client]
import java.net.*;
import java.util.Random;
import java.io.*;


public class Client {
	ObjectOutputStream output;
	ObjectInputStream input;
	Socket client;
	String ind;
	int	porta;
	boolean serverpresente;
	int tipoclient;

	
	public Client(String args[]) {
		tipoclient = TipoClient(args);
	}
	
	/* restituisce:
			0 il client si collega al server master
			1 il client si collega al server slave
			2 il client sceglie a chi collegarsi in modo random
			-1 se scelta non valida
	*/		
	public int TipoClient (String args[]) {
		if (args.length==1) {
			String scelta = args[0].toLowerCase();
			if (scelta.equals("master")) {
				//System.out.println("Mi collego al server Master");
				return 0;
			}
			else
				if (scelta.equals("slave")) {
					//System.out.println("Mi collego al server Slave");
					return 1;
				}
				else {
					System.out.println("\nArgomento non valido");
					System.out.println("\nPer collegarsi in modo casuale ad uno dei due server usare:");
					System.out.println("\n  " + this.getClass().getName());
					System.out.println("\nPer collegarsi al server master usare:");
					System.out.println("\n  " + this.getClass().getName() + " master");
					System.out.println("\nPer collegarsi al server slave usare:");
					System.out.println("\n  " + this.getClass().getName() + " slave");
					return -1;
				}
		}
		else {
			System.out.println("Scelta Random del sever");
			return 2;
		}
	}
	
	public void settaIndirizzoePorta() {
		switch(tipoclient) {
			case 0 : porta=Def.portaMaster;
							 ind=Def.indMaster;
						 	 break; 
			case 1 : porta=Def.portaSlave;
							 ind=Def.indSlave;
							 break; 
			case 2 : int ran=sceltaRandom();
							 if (ran==0) {
								 porta=Def.portaMaster;
							 	 ind=Def.indMaster;
							 }
							 else {
							 	 porta=Def.portaSlave;
							 	 ind=Def.indSlave;
							 }
		}					 
 	}
	
	public int sceltaRandom() {
		//0 master; 1 slave
		Random rand = new Random(System.currentTimeMillis());
		int num =Math.abs(rand.nextInt()) % 2;
		return num;
		} 
	
	public void mostraParametriDestinazione() {
		InetAddress dest = client.getInetAddress();
  	String name = dest.getHostName();
  	byte indirizzoip[] = dest.getAddress();
  	int port = client.getPort();
  	System.out.println("Server a cui si  collegati: " + name);
  	System.out.print("Indirizzo IP Server: ");
  	for(int i=0;i<indirizzoip.length;++i)
  	  System.out.print((indirizzoip[i]+256)%256+".");
  	System.out.println();
   	System.out.println("Porta Server: " + port);
 	}
 
  public void mostraParametriLocali(){
  	InetAddress indirizzolocale = null;
  	try{
    	indirizzolocale = InetAddress.getLocalHost();
  	} catch (UnknownHostException ex){}
  	String name = indirizzolocale.getHostName();
  	byte indirizzoip[] = indirizzolocale.getAddress();
  	int port = client.getLocalPort();
    System.out.println("Io sono il Client: "+name);
  	System.out.print("Indirizzo IP Client: "+indirizzolocale);
  	System.out.println();
   	System.out.println("Porta Client: "+port);
 	}

	
	public boolean lanciaClient() {
		try {
			boolean scelta;
			do {
				//Fase1: crea una socket per la connessione
				System.out.println("Richiesta di connessione");  
				client = new Socket(ind,porta);
				//Fase2: ottenere flussi di input output
				output = new ObjectOutputStream(client.getOutputStream());
				output.flush();
				input = new ObjectInputStream(client.getInputStream());
				//System.out.println("Ottenuti i/o streams");
				//Fase3: Elaborazione connessione
				mostraParametriDestinazione();
				mostraParametriLocali();
				int nsale=input.readInt();
				int[] postidisponibili = new int[nsale];
				
				System.out.println("--------------------------------------");
				for (int i=0;i<nsale;i++) {
			  	postidisponibili[i]=input.readInt();
			  	System.out.println("Sala " + (i+1) + ": "+ postidisponibili[i] + " posti disponibili");
				}
				System.out.println("--------------------------------------");
				boolean interononvalido=true;
				int sala=0;
				while(interononvalido) {
   				System.out.println("Inserisci numero sala: ");
	  			sala=leggiInt(1,9);
	  			if (!(sala==-1)) {
	  				if (postidisponibili[sala-1]==0) System.out.println("Sala completa");
						else {
	  			  	//numero valido
	  			  	interononvalido=false;
	  				}
	  			} 
	  			else System.out.println("devi inserire un intero tra 1 e 9");
				}
				interononvalido=true;		
				int postirichiesti=0;
				while(interononvalido) {
					System.out.println("Numero di biglietti richiesti: ");
	  			postirichiesti=leggiInt(1,postidisponibili[sala-1]);
	  			if (!(postirichiesti==-1)) {
	  				//numero valido
	  				interononvalido=false;
	  			}
		  		else System.out.println("posti disponibili:"+postidisponibili[sala-1]);
				} 
				output.writeInt(sala);
				output.writeInt(postirichiesti);
				output.flush();
				System.out.println("--------------------------------------");
				
				//System.out.println("Ho inviato richiesta");
				//Pausa.premiEnter();
				
				boolean effettuato=input.readBoolean();
				if (effettuato) {
					try {
						
						//System.out.println("Ho ricevuto risposta affermativa");
						//Pausa.premiEnter();
								
						output.writeBoolean(true); //conferma di avere ricevuto
			 			output.flush();
						System.out.println(postirichiesti + " biglietti confermati per la sala " + sala);
					} catch (IOException io) {
							System.out.println("I posti non sono stati confermati: ripetere");
					}
				}
				else 
					System.out.println("Non  stato possibile effettuare la richiesta per la sala " + sala);
				System.out.println("--------------------------------------");
				//Fase4: Chiusura connessione
				System.out.println("Chiudere il Client (S/N)");
				scelta=leggiChar();
				try {	
					output.writeBoolean(scelta); //conferma di avere ricevuto
			 		output.flush();
				} catch (IOException io) {}
					
				if (scelta) {
					System.out.println("Chiusura connessione");
					try {
						input.close();
						output.close();
						client.close();
					} catch (IOException io) {}
				}
			} while (!scelta);
			return false;			
		} catch (IOException io) {
			//mi accorgo se non esiste il server o  caduto
			System.out.println("Server non presente o caduto [Porta: "+porta+ "]");
			System.out.println("Ripetere la richiesta sull'altro server");
			//io.printStackTrace();
			return true;
		}
	}
	
public int leggiInt(int inf,int sup) {	
	//restituisce -1 se non ok, altrimenti l'intero letto
	try {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String linea=in.readLine();
		try {	
			int intero=Integer.parseInt(linea);
			if ((inf<=intero)&&(intero<=sup)) return intero;
			else return -1;
		} catch (NumberFormatException e) {
		  return -1;
	  }	
	} catch (IOException io) {
	 	return -1;
	}
}
	
public boolean leggiChar() {
	try { 
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String linea=in.readLine();
		if(linea.length()>0){
     	linea=linea.toUpperCase();
     	switch (linea.charAt(0)){
     		case 'S':	return true;
 				default :	return false;
      }
    }
    else {return true;}
  } catch (IOException io) {
		//errore in lettura da tastiera, scelgo di terminare
	  return true;
	}	
}
	
	
	public static void main (String args[]) {
		Client cl = new Client(args);
		
		if (cl.tipoclient!=-1) {
			cl.settaIndirizzoePorta();
			//System.out.println( cl.porta + " " + cl.ind );
			boolean caduto=cl.lanciaClient();
			while ((caduto)&&(cl.tipoclient==2)) {
				if (cl.porta==Def.portaMaster) {
					cl.porta=Def.portaSlave;
					cl.ind=Def.indSlave;
				}
				else {
					cl.porta=Def.portaMaster;
					cl.ind=Def.indMaster;
				}
				caduto=cl.lanciaClient();
			}
		}
	}
}
		
					
		